namespace eval ::WinUtils:: {
    
}

proc ::WinUtils::confirmBox {w txt {option okcancel} {title "Confirm"}} {
	
    global msgboxIcon msgboxType
    
    if { $option == "okcancel" } {
	    set button [tk_messageBox -type okcancel \
		-title "$title" -parent $w \
		-message $txt]
	} else {
		set button [tk_messageBox -type $option \
		-title "$title" -icon warning -parent $w \
		-message $txt]
	}
	return $button
}

proc ::WinUtils::WarningLine {state} {
    # Enable or disabled the warning line
    # State 1 => Disable
    #       0 => Enable

    if {$state =="Enable"} {
	# Check the GiD state
	set gwhat [.central.s disable warnline]
	if {$gwhat =="1"} {
	    .central.s disable warnline 0 
	}
    } elseif {$state =="Disable"} {
	# Check the GiD state
	set gwhat [.central.s disable warnline]
	if {$gwhat =="0"} {
	    .central.s disable warnline 1 
	}
    }
}

proc ::WinUtils::PrintArray {a {pattern *}} {
    # ABSTRACT:
    # Print the content of array a to WarnWinText window
    
    upvar 1 $a array  
    if {![array exists array]} {
	error "\"$a\" isn't an array"
    }
    set maxl 0
    foreach name [lsort [array names array $pattern]] {
	if {[string length $name] > $maxl} {
	    set maxl [string length $name]
	}
    }
    set maxl [expr {$maxl + [string length $a] + 2}]
    foreach name [lsort [array names array $pattern]] {
	set nameString [format %s(%s) $a $name]
	WarnWinText "[format "%-*s = %s" $maxl $nameString $array($name)]"
    }
}

proc ::WinUtils::GetImage { imageid } {
    # ABSTRACT:
    # Get images from the image subdirectory
    # wa $imageid
    global KPriv
	
	if { $imageid != "" && [file exists [file native "$KPriv(dir)/$KPriv(imagesdir)/${imageid}"]] } {
	    #msg $KPriv(dir)/$KPriv(imagesdir)/${imageid}
	    #msg "imgId:$imageid [Bitmap::get $KPriv(dir)/$KPriv(imagesdir)/${imageid}]"
	    return [Bitmap::get [file native "$KPriv(dir)/$KPriv(imagesdir)/${imageid}"]]
    } else {
	    #msg "NoImage(-1)"
	    return -1
    }
}


proc ::WinUtils::Print {w} {

    if {$::tcl_platform(platform) ne "windows"} {
    WarnWin [= "Printing is only supported under Windows"]
    return 0
    }

    set tempdir ""
    set tempdir [::KUtils::GiveTempDir]
    if {$tempdir ==""} {
    WarnWin [= "An error has been detected when get a temporal directory"]
    return 0
    }
    set filename $tempdir/print.txt
    # Save the license information to this file
    if { [catch { set fileid [open $filename w] }] } {
    WarnWin [= "Cannot write file %s. Permission denied" $file].
    return 0
    }
    fconfigure $fileid -encoding utf-8
    puts $fileid \ufeff[$w get 1.0 end]
    close $fileid
    exec cmd /c start /min notepad /p $filename
    file delete $filename
 }

